<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Load all orders - Danh sách đơn hàng</title>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />

    <style>
      th {
        background-color: #5b9ad4;
        color: white;
      }

      table {
        background-color: #d3dfef;
      }

      th,
      td {
        border: 1px solid white;
      }

      tr:nth-child(even) {
        background-color: #eaeef6;
      }
    </style>
  </head>

  <body onload="onPageLoading()">
    <div class="container-fluid pt-4">
      <h2 class="text-center pb-3">DANH SÁCH LIÊN HỆ</h2>

      <table class="table" id="table-contact">
        <thead>
          <tr>
            <th scope="col">STT</th>
            <th scope="col">Name</th>
            <th scope="col">Email</th>
            <th scope="col">Message</th>
            <th scope="col">Ngày liên hệ</th>
            <th scope="col">Action</th>
          </tr>
        </thead>
        <tbody></tbody>
      </table>
    </div>
  </body>

  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";

    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    const gEND_ROW_TABLE = -1;
    // Biến toàn cục định nghĩa chỉ số các cột tương ứng
    const gSTT_COL = 0;
    const gNAME_COL = 1;
    const gEMAIL_COL = 2;
    const gMESSAGE_COL = 3;
    const gNGAY_LIEN_HE_COL = 4;
    const gACTION_COL = 5;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm thực hiện khi load trang
    function onPageLoading() {
      getContactList();
    }

    // onBtnSuaClick, ấn nút Sửa
    function onBtnSuaClick(paramSuaButton) {
      var vId = paramSuaButton.dataset.id;
      console.log("id từ nút Sửa: " + vId);

      const vCONTACT_DETAIL_URL = "contactDetail.html";
      var vUrlSiteToOpen = vCONTACT_DETAIL_URL + "?" + "id=" + vId;
      window.location.href = vUrlSiteToOpen;
    }

    // onBtnXoaClick, ấn nút Xóa
    function onBtnXoaClick(paramXoaButton) {
      var vId = paramXoaButton.dataset.id;
      if (confirm("Bạn có chắc chắn muốn xóa liên hệ này không?") == true) {
        var vIdObj = {
          id: "",
        };

        //B1: Thu thập dữ liệu
        thuThapDuLieuDelete(paramXoaButton, vIdObj);
        //B2: Kiểm tra dữ liệu
        var vCheckD = kiemTraDuLieuDelete(vIdObj);
        if (vCheckD) {
          //B3: gọi api để xóa
          var vXmlHttpD = new XMLHttpRequest();
          goiApiDelete(vXmlHttpD, vIdObj);
          vXmlHttpD.onreadystatechange = function () {
            if (
              this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
              this.status == gREQUEST_STATUS_OK
            ) {
              console.log("Xóa contact " + vIdObj.id + " thành công!");
              alert("Xóa contact thành công!");
              window.location.href = "listContact.html";
            }
          };
        }
      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm lấy contact list từ server và load về trang web
    function getContactList() {
      //B3: gọi api lấy danh sách Liên hệ (Contacts)
      var vXhttp = new XMLHttpRequest();
      goiApiContactList(vXhttp);

      vXhttp.onreadystatechange = function () {
        if (
          this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
          this.status == gREQUEST_STATUS_OK
        ) {
          console.log(vXhttp.responseText); // ghi response text ra console.log
          var bContactList = JSON.parse(vXhttp.responseText);
          //B4: hiển thị dữ liệu
          hienThiDuLieuCL(bContactList);
        }
      };
    }

    //hàm gọi api lấy danh sách Liên hệ (Contacts)
    function goiApiContactList(paramXhttp) {
      var vAPI_URL = gBASE_URL + "contacts";

      paramXhttp.open("GET", vAPI_URL, true);
      paramXhttp.send();
    }

    //hàm hiển thị dữ liệu, load contact list ra table
    function hienThiDuLieuCL(paramContactList) {
      var vTable = document.getElementById("table-contact");
      var vTableBody = vTable.getElementsByTagName("tbody")[0];

      for (var bIndex = 0; bIndex < paramContactList.length; bIndex++) {
        var vContactObj = paramContactList[bIndex];

        // tạo dòng mới cho bảng và ghi vào các giá trị
        var vRow = vTableBody.insertRow(gEND_ROW_TABLE);

        var vCellStt = vRow.insertCell(gSTT_COL);
        var vCellName = vRow.insertCell(gNAME_COL);
        var vCellEmail = vRow.insertCell(gEMAIL_COL);
        var vCellMessage = vRow.insertCell(gMESSAGE_COL);
        var vCellNgayLienHe = vRow.insertCell(gNGAY_LIEN_HE_COL);
        var vCellAction = vRow.insertCell(gACTION_COL);

        vCellStt.innerHTML = bIndex + 1;
        vCellName.innerHTML = vContactObj.name;
        vCellEmail.innerHTML = vContactObj.email;
        vCellMessage.innerHTML = vContactObj.message;
        vCellNgayLienHe.innerHTML = vContactObj.createDate;

        var vSuaButton = document.createElement("button"); //tạo element button
        vCellAction.appendChild(vSuaButton); // gắn nó vào ô
        vSuaButton.innerHTML = "Sửa"; //thêm label (nhãn của  button)
        vSuaButton.className = "btn btn-success sua-contact-button";
        vSuaButton.setAttribute("data-id", vContactObj.id);
        vSuaButton.setAttribute("onclick", "onBtnSuaClick(this)");
        vSuaButton.style.marginRight = "3px";
        vSuaButton.style.marginBottom = "3px";

        var vXoaButton = document.createElement("button");
        vCellAction.appendChild(vXoaButton);
        vXoaButton.innerHTML = "Xóa";
        vXoaButton.className = "btn btn-danger xoa-contact-button";
        vXoaButton.setAttribute("data-id", vContactObj.id);
        vXoaButton.setAttribute("onclick", "onBtnXoaClick(this)");
        vXoaButton.style.marginBottom = "3px";
      }
    }

    //hàm thu thập dữ liệu id của nút Delete
    function thuThapDuLieuDelete(paramPDeleteButton, paramIdObj) {
      var vId = paramPDeleteButton.dataset.id;
      console.log(vId);
      paramIdObj.id = vId;
    }

    //hàm kiểm tra dữ liệu của nút Delete
    function kiemTraDuLieuDelete(paramIdObj) {
      if (typeof paramIdObj.id == "undefined") {
        alert("lỗi id");
        return false;
      }

      return true;
    }

    //hàm gọi api để xóa contact
    function goiApiDelete(paramXmlHttpContact, paramIdObj) {
      const vAPI_URL = gBASE_URL + "contacts/";

      paramXmlHttpContact.open("DELETE", vAPI_URL + paramIdObj.id, true);
      paramXmlHttpContact.send();
    }
  </script>
</html>
